
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>30分钟正则表达式指导 / iVAN</title>

    <meta name="description" content="30分钟正则表达式指导 正则 by Jim Hollenhorst  译 寒带鱼 你是否曾经想过正则表达式是什么,怎样能够快速得到对它的一个基本的认识?我的目的就是在30分钟内带你入门并且对正则表达式有一个基本的理解.事实是正则表达式并没有它看起来那么复杂.学习它最好的办法就是开始写正则表达式并且不断实践.在最初的30分钟之后,你就应该知道一些基本的结构并且有能力在你的程序或者web页面中设计和使用正则表达式了.对那些想要深入研究的人,现在已经有很多非常好的可用资源来让你更深入的学习. 到底什么是正则表达式? 我相信你">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">30分钟正则表达式指导</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>正则</p>
<p>　　by Jim Hollenhorst  译 寒带鱼</p>
<p>　　你是否曾经想过正则表达式是什么，怎样能够快速得到对它的一个基本的认识？我的目的就是在30分钟内带你入门并且对正则表达式有一个基本的理解。事实是正则表达式并没有它看起来那么复杂。学习它最好的办法就是开始写正则表达式并且不断实践。在最初的30分钟之后，你就应该知道一些基本的结构并且有能力在你的程序或者web页面中设计和使用正则表达式了。对那些想要深入研究的人，现在已经有很多非常好的可用资源来让你更深入的学习。</p>
<p>　　到底什么是正则表达式？</p>
<p>　　我相信你对模式匹配的“计算机通配符”字符应该比较熟悉了。例如，如果你想要在一个Windows文件夹中找到所有Mircosoft Word文件，你要搜索“*.doc”，因为你知道星号会被解释为一个通配符，它匹配所有序列的字符串。正则表达式就是这种功能的一个更加细节的扩展。</p>
<p>　　在写处理文本的程序或者web页面时，定位匹配复杂模式的字符串是很常见的。正则表达式就是用来描述这类模式的。这样，一个正则表达式就是一个模式的缩减代码。例如，模式“\w+”是表达“匹配任何包含字母数字字符的非空字符串”的精确方法。.NET框架提供了一个功能强大类库，它使得在你的应用程序中包含正则表达式更加容易。使用这个库，你可以轻易地搜索和替换文本，解码复杂的标题，解析语言，或者验证文本。</p>
<p>　　学习正则表达式的神秘的语法的一个好办法是用例子作为开始学习的对象，然后实践创建自己的正则表达式。</p>
<p>　　让我们开始吧！</p>
<p>　　一些简单的例子<br /> </p>
<p>　　搜索Elvis</p>
<p>　　假设你要花费你所有的空余时间来扫描文档来寻找Elvis仍然活着的证据。你可以使用下面的正则表达式来搜索：</p>
<p>　　1. elvis -- Find elvis</p>
<p>　　这是搜索精确字符序列的一个完全合法的正则表达式。在.NET中，你可以轻松的设置选项来忽略字符的各种情况，所以这个表达式将会匹配“Elivs”，“ELVIS”，或者“eLvIs”。不幸的是，它也将匹配单词“pelvis”的后五个字母。我们可以改进这个表达式如下：</p>
<p>　　2. \belvis\b -- Find elvis as a whole word</p>
<p>　　现在事情变得更加有趣了。“\b”是一个特殊代码，它表示“匹配任何单词的开头或结尾的位置”。这个表达式将只匹配完整的拼写为“elvis”的单词，无论是小写的还是大写的情况。</p>
<p>　　假设你想要找到所有这样的行，在其中单词“elvis”后面都跟着单词“alive”。句点或者点“.”是一个特殊代码匹配除了换行符之外的任何字符。星号“*”表示重复前面的部分有必要的次数以保证能够有一个匹配。这样，“.*”表示“匹配除了换行符之外的任意数目的字符”。现在建立一个表示“搜索在同一行内后面跟着单词‘alive’的单词‘elvis’”的表达式就是一件简单的事了。</p>
<p>　　3. \belvis\b.*\balive\b -- Find text with "elvis" followed by "alive"</p>
<p>　　仅仅使用几个特殊字符我们就开始创建功能强大的正则表达式了，而且它们已经开始变得难以被我们人类理解了。</p>
<p>　　让我们看看另一个例子。</p>
<p>　　确定电话号码的合法性</p>
<p>　　假设你的web页面收集顾客的7位电话号码，而且你希望验证输入的电话号码是正确的格式，“xxx-xxxx”，这里每个“x”是一个数字。下面的表达式将搜索整个文本寻找这样的一个字符串：</p>
<p>　　4. \b\d\d\d-\d\d\d\d -- Find seven-digit phone number<br />每个“\d”表示“匹配任何单个数字”。“-”没有特殊的意义并且按照字面解释，匹配一个连字符。要避免繁琐的重复，我们可以使用一个含有相同含义的速记符：</p>
<p>　　5. \b\d{3}-\d{4} -- Find seven-digit phone number a better way<br />“\d”后面的“{3}”表示“重复前面的字符三次”。</p>
<p>　　.NET正则表达式的基础</p>
<p>　　让我们探索一下.NET中正则表达式的基础</p>
<p>　　特殊字符</p>
<p>　　你应该知道几个有特殊意义的字符。你已经见过了“\b”，“.”，“*”，和“\d”。要匹配任何空白字符，像空格，制表符和换行符，使用“\s”。相似地，“\w”匹配任何字母数字字符。</p>
<p>　　让我们尝试更多的例子：</p>
<p>　　6. \ba\w*\b -- Find words that start with the letter a</p>
<p>　　这个搜索一个单词的开头（\b），然后是一个字母“a”，接着是任意次数重复的字母数字字符（\w*），最后是一个单词的结尾（\b）。</p>
<p>　　7. \d+ -- Find repeated strings of digits</p>
<p>　　这里，“+”与“*”是相似的，除了它需要至少一次重复。</p>
<p>　　8. \b\w{6}\b -- Find six letter words</p>
<p>　　在Expresso中测试这几个表达式，然后实践创建你自己的表达式。下面是一个说明有特殊含义的字符的表格：</p>
<table>
<tr>
<td>. </td>
<td>匹配除换行符外的任何字符</td>
</tr>
<tr>
<td>\w</td>
<td> 匹配任何字母数字字符</td>
</tr>
<tr>
<td>\s</td>
<td>匹配任何空白字符</td>
</tr>
<tr>
<td>\d</td>
<td>匹配任何数字</td>
</tr>
<tr>
<td>\b</td>
<td>匹配一个单词的开始或结尾</td>
</tr>
<tr>
<td>^</td>
<td>匹配字符串的开始</td>
</tr>
<tr>
<td>$</td>
<td>匹配字字符串的结尾</td>
</tr>
</table>
<p>表1 正则表达式的常用特殊字符</p>
<p>　　开始阶段</p>
<p>　　特殊字符“^”和“$”被用来搜索那些必须以一些文本开头和（或）以一些文本结尾的文本。特别是在验证输入时特别有用，在这些验证中，输入的整个文本必须要匹配一个模式。例如，要验证一个7位电话号码，你可能要用：</p>
<p>　　9. ^\d{3}-\d{4}$ -- Validate a seven-digit phone number</p>
<p>　　这是和第5个例子一样的，但是强迫它符合整个文本字符串，匹配文本的头尾之外没有其他字符。通过在.NET中设置“Multiline”选项，“^”和“$”改变他们的意义为匹配一行文本的起点和结束，而不是整个正文字符串。Expresso的例子使用这个选项。</p>
<p>　　换码字符</p>
<p>　　当你想要匹配这些特殊字符中的一个时会产生一个错误，像“^”或者“$”。使用反斜线符号来去掉它们的特殊意义。这样，“\^”，“\.”，和“\\”，分别匹配文本字符“^”，“.”，和“\”。</p>
<p>　　重复</p>
<p>　　你已经见过了“{3}”和“*”可以指定一个单独字符的重复次数。稍后，你会看到相同的语法怎样用来重复整个子表达式。此外还有其他几种方法来指定一个重复，如下表所示：</p>
<table>
<tr>
<td>*</td>
<td>重复任意次数</td>
</tr>
<tr>
<td>+</td>
<td>重复一次或多次</td>
</tr>
<tr>
<td>?</td>
<td>重复一次或多次</td>
</tr>
<tr>
<td>{n}</td>
<td>重复n次</td>
</tr>
<tr>
<td>{n,m}</td>
<td>重复最少n次，最多m次</td>
</tr>
<tr>
<td>{n,}</td>
<td>重复最少n次</td>
</tr>
</table>
<p>表2 常用量词</p>
<p>　　让我们试试几个例子：</p>
<p>10. \b\w{5,6}\b -- Find all five and six letter words</p>
<p>11. \b\d{3}\s\d{3}-\d{4} -- Find ten digit phone numbers</p>
<p>12. \d{3}-\d{2}-\d{4} -- Social security number</p>
<p>13. ^\w* -- The first word in the line or in the text</p>
<p>　　在设置和不设置“Multiline”选项的时试试最后一个例子，它改变了“^”的含义。</p>
<p>　　字符集合</p>
<p>　　搜索字母数字字符，数字，和空白字符是容易的，但如果你需要搜索一个字符集合中的任意字符时怎么办？这可以通过在方括号中列出想要的字符来轻松的解决。这样，“[aeiou]”就能匹配任意韵母，而“[.?!]”就匹配句子末尾的标点。在这个例子中，注意“.”和“?”在方括号中都失去了他们的特殊意义而被解释为文本含义。我们也可以指定一个范围的字符，所以“[a-z0-9]”表示“匹配任何小写字母或者任何数字”。</p>
<p>　　让我们试试一个搜索电话号码的更加复杂的表达式：</p>
<p>14. \(?\d{3}[) ]\s?\d{3}[- ]\d{4} A ten digit phone number</p>
<p>　　这个表达式将会搜索几种格式的电话号码，像“(800)325-3535”或者“650 555 1212”。“\(?”搜索0个或1个左圆括号，“[)]”搜索一个右圆括号或者一个空格。“\s?”搜索0个或一个空白字符。不幸的是，它也会找到像“650)555-1212”这样括号没有去掉的情况。在下面，你会看到怎样用可选项解决这个问题。</p>
<p>　　否定</p>
<p>　　有些时候我们需要搜索一个字符，它不是一个很容易定义的字符集合的成员。下面的表格说明了这种字符怎样指定：</p>
<table>
<tr>
<td>\W</td>
<td>匹配任何非字母数字字符</td>
</tr>
<tr>
<td>\S</td>
<td>匹配任何非空白字符</td>
</tr>
<tr>
<td>\D</td>
<td>匹配任何非数字字符</td>
</tr>
<tr>
<td>\B</td>
<td>匹配非单词开始或结束的位置</td>
</tr>
<tr>
<td>[^x]</td>
<td>匹配任何非x字符</td>
</tr>
<tr>
<td>[^aeiou]</td>
<td>匹配任何不在aeiou中的字符</td>
</tr>
</table>
<p>            表3 怎样指定你不想要东西<br />15. \S+ -- All strings that do not contain whitespace characters</p>
<p>　　后面，我们会看到怎样使用“lookahead”和“lookbehind”来搜索缺少更加复杂的模式的情况。</p>
<p>　　可选项</p>
<p>　　要从几个可选项中选择，允许符合任何一个的匹配，使用竖杠“|”来分隔可选项。例如，邮政编码有两种，一个是5位的，另一个是9位的加一个连字符。我们可以使用下面的表达式找到任何一种：</p>
<p>16. \b\d{5}-\d{4}\b|\b\d{5}\b -- Five and nine digit Zip Codes</p>
<p>　　当使用可选项时，顺序是很重要的因为匹配算法将试图先匹配最左面的选择。如果这个例子中的顺序颠倒过来，表达式将只能找到5位的邮政编码，而不会找到9位的。我们可以使用可选项来改进十位电话号码的表达式，允许包含区码无论是通过空白字符还是连字符划分的：</p>
<p>17. (\(\d{3}\)|\d{3})\s?\d{3}[- ]\d{4} -- Ten digit phone numbers, a better way</p>
<p>　　分组</p>
<p>　　圆括号可以用来划分一个子表达式来允许重复或者其他特殊的处理，例如：</p>
<p>18. (\d{1,3}\.){3}\d{1,3} -- A simple IP address finder</p>
<p>　　表达式的第一部分搜索后面跟着一个“\.”的一个一位到三位的数字。这被放在圆括号中并且通过使用修饰符“{3}”被重复三次，后面跟着与之前一样的表达式而不带后缀部分。</p>
<p>　　不幸的是，这个例子允许IP地址中被分隔的部分是任意的一位，两位，或三位数字，尽管一个合法的IP地址不能有大于255的数字。要是能够算术比较一个获取的数字N使N&lt;256就好了，但是只用正则表达式是不能够办到的。下一个例子使用模式匹配测试了基于第一位数字的多种可选项来保证限制数字的取值范围。这表明一个表达式会变得很笨重，尽管搜索模式的描述是简单的。</p>
<p>19. ((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?) -- IP finder</p>
<p>　　一个“回引”用来搜索前面被一个分组捕获的已匹配文本的再现。例如，“\1”表示“匹配分组1中已捕获到的文本”。下面是一个例子：</p>
<p>20. \b(\w+)\b\s*\1\b -- Find repeated words</p>
<p>　　它的运行过程是先捕获一个分组1中“(\w+)”表示的至少包含一个字母数字字符的字符串，但仅当它是一个单词的开始或结束字符时才行。然后它搜索任意数量的空白字符“\s*”后跟以被捕获的文本“\1”结尾的单词。</p>
<p>　　在上面的例子中，想要替换分组“(\w+)”这种写法，我们可以把它写成“(?&lt;Word&gt;\w+)”来给这个分组命名为“Word”。一个对这个分组的回引可以写成“\k&lt;Word&gt;”。试试下面的例子：</p>
<p>21. \b(?&lt;Word&gt;\w+)\b\s*\k&lt;Word&gt;\b -- Capture repeated word in a named group</p>
<p>　　通过使用圆括号，有很多可用的特殊用途的语法元素。一些最常用的归纳如下面这张表格：</p>
<table>
<tr>
<td>捕获</td>
</tr>
<tr>
<td>(exp)</td>
<td>匹配exp并且在一个自动计数的分组中捕获它</td>
</tr>
<tr>
<td>(?&lt;name&gt;exp)</td>
<td>匹配exp并且在一个命名的分组中捕获它
</td>
</tr>
<tr>
<td>(?:exp)</td>
<td>匹配exp并且不捕获它</td>
</tr>
<tr>
<td>察看</td>
</tr>
<tr>
<td>(?=exp)</td>
<td>匹配任何后缀exp之前的位置</td>
</tr>
<tr>
<td>(?&lt;=exp)</td>
<td>匹配任何前缀exp之后的位置</td>
</tr>
<tr>
<td>(?!exp)</td>
<td>匹配任何未找到的后缀exp之后的位置</td>
</tr>
<tr>
<td>(?&lt;!exp)</td>
<td>匹配任何未找到的前缀exp之前的位置</td>
</tr>
<tr>
<td>评论</td>
</tr>
<tr>
<td>(?#comment)</td>
<td>评论</td>
</tr>
</table>
<p>表4 常用分组结构</p>
<p>　　前两个我们已经说过了。第三个“(?:exp)”不会改变匹配行为，它只是不像前两个那样捕获已命名的或者计数的分组。</p>
<p>　　确定察看（Positive Lookaround）</p>
<p>　　下面四个是所谓的前向或后向断言。它们从当前的匹配向前或向后寻找需要的东西而不在匹配中包含它们。这些表达式匹配一个类似于“^”或“\b”的位置而不匹配任何文本，理解这个是很重要的。由于这个原因，他们也被称为“零宽度断言”。最好用例子来解释它们：</p>
<p>　　“(?=exp)”是“零宽度确定前向断言”。它匹配一个文本中在给定后缀之前的位置，但不在匹配中包含这个后缀：</p>
<p>22. \b\w+(?=ing\b) -- The beginning of words ending with "ing"</p>
<p>　　“(?&lt;=exp)”是“零宽度确定后向断言”。它匹配在给定前缀后面的位置，但不在匹配中包含这个前缀：</p>
<p>23. (?&lt;=\bre)\w+\b -- The end of words starting with "re"</p>
<p>　　下面这个例子可以用来重复向三位数为一组的数字中插入逗号的例子：</p>
<p>24. (?&lt;=\d)\d{3}\b -- Three digits at the end of a word, preceded by a digit</p>
<p>　　下面是一个同时搜索前缀和后缀的例子：</p>
<p>25. (?&lt;=\s)\w+(?=\s) -- Alphanumeric strings bounded by whitespace</p>
<p>　　否定察看（Negative Lookaround）</p>
<p>　　之前，我说明了怎样搜索一个不是特定字符或一个字符集合的成员的字符。那么如果我们想要简单的验证一个字符没有出现，但是不想匹配任何东西怎么办？例如，如果我们想要搜索其中“q”不是后跟着“u”的单词怎么办？我们可以尝试：</p>
<p>26. \b\w*q[^u]\w*\b -- Words with "q" followed by NOT "u"</p>
<p>　　运行例子你就会看到如果“q”是一个单词的最后一个字母就不会匹配，比如“Iraq”。这是因为“[^q]”总是匹配一个字符。如果“q”是单词的最后一个字符，它会匹配后面跟着的空白字符，所以这个例子中表达式结束时匹配两个完整的单词。否定察看可以解决这个问题，因为它匹配一个位置而不消耗任何文本。与确定察看一样，它也可以用来匹配一个任意复杂的子表达式的位置，而不仅仅是一个字符。我们现在可以做得更好：</p>
<p>27. \b\w*q(?!u)\w*\b -- Search for words with "q" not followed by "u"</p>
<p>　　我们使用“零宽度否定前向断言”，“(?!exp)”，只有当后缀“exp”没有出现时它才成功。下面是另一个例子：</p>
<p>28. \d{3}(?!\d) -- Three digits not followed by another digit</p>
<p>　　相似地，我们可以使用“(?&lt;!exp)”，“零宽度否定后向断言”，来搜索文本中的一个位置，这里前缀“exp”没有出现：</p>
<p>29. (?&lt;![a-z ])\w{7} -- Strings of 7 alphanumerics not preceded by a letter or space</p>
<p>　　这里是另一个使用后向的例子：</p>
<p>30. (?&lt;=&lt;(\w+)&gt;).*(?=&lt;\/\1&gt;) -- Text between HTML tags</p>
<p>　　这个使用后向搜索一个HTML标记，而使用前向搜索对应的结束标记，这样，就能获得中间的文本而不包括两个标记。</p>
<p>　　评论</p>
<p>　　标点的另一个用法是使用“(?#comment)”语法包含评论。一个更好的办法是设置“Ignore Pattern Whitespace”选项，它允许空白字符插入表达式然后当使用表达式时忽略它。设置了这个选项之后，任何文本每行末尾在数字符号“#”后面的东西都被忽略。例如，我们可以格式化先前的例子如下：</p>
<p>31. Text between HTML tags, with comments</p>
<p>(?&lt;=    # Search for a prefix, but exclude it<br />  &lt;(\w+)&gt; # Match a tag of alphanumerics within angle brackets<br />)          # End the prefix</p>
<p>.*        # Match any text</p>
<p>(?=     # Search for a suffix, but exclude it<br />  &lt;\/\1&gt;  # Match the previously captured tag preceded by "/"<br />)         # End the suffix</p>
<p>　　贪婪与懒惰</p>
<p>　　当一个正则表达式有一个可以接受一个重复次数范围的量词（像“.*”），正常的行为是匹配尽可能多的字符。考虑下面的正则表达式：</p>
<p>32. a.*b -- The longest string starting with a and ending with b</p>
<p>　　如果这被用来搜索字符串“aabab”，它会匹配整个字符串“aabab”。这被称为“贪婪”匹配。有些时候，我们更喜欢“懒惰”匹配，其中一个匹配使用发现的最小数目的重复。表2中所有的量词可以增加一个问号“?”来转换到“懒惰”量词。这样，“*?”的意思就是“匹配任何数目的匹配，但是使用达到一个成功匹配的最小数目的重复”。现在让我们试试懒惰版本的例子(32)：</p>
<p>33. a.*?b -- The shortest string starting with a and ending with b</p>
<p>　　如果我们把这个应用到相同的字符串“aabab”，它会先匹配“aab”然后匹配“ab”。</p>
<table>
<tr>
<td>*?</td>
<td>重复任意次数，但尽可能少</td>
</tr>
<tr>
<td>+? </td>
<td>匹配一次或多次，但尽可能少</td>
</tr>
<tr>
<td>??</td>
<td>重复零次或多次，但尽可能少</td>
</tr>
<tr>
<td>{n,m}?</td>
<td>重复最少n次，但不多于m次，但尽可能少</td>
</tr>
<tr>
<td>{n,}?</td>
<td>重复最少n次，但尽可能少</td>
</tr>
</table>
<p>表5 懒惰量词</p>
<p>　　我们遗漏了什么？</p>
<p>　　我已经描述了很多元素，使用它们来开始创建正则表达式；但是我还遗漏了一些东西，它们在下面的表中归纳出来。这些中的很多都在项目文件中使用额外的例子说明了。例子编号在这个表的左列中列出。</p>
<table>
<tr>
<td></td>
<td>\a</td>
<td>报警字符</td>
</tr>
<tr>
<td></td>
<td>\b</td>
<td>通常是单词边界，但是在一个字符集合中它表示退格键</td>
</tr>
<tr>
<td></td>
<td>\t </td>
<td>制表符</td>
</tr>
<tr>
<td>34</td>
<td>\r</td>
<td>回车</td>
</tr>
<tr>
<td></td>
<td>\v</td>
<td>垂直制表符</td>
</tr>
<tr>
<td></td>
<td>\f</td>
<td>分页符</td>
</tr>
<tr>
<td>35</td>
<td>\n</td>
<td>换行符</td>
</tr>
<tr>
<td></td>
<td>\e</td>
<td>ESC</td>
</tr>
<tr>
<td>36</td>
<td>\nnn</td>
<td>ASCII码八进制数为nnn的字符</td>
</tr>
<tr>
<td>37</td>
<td>\xnn</td>
<td>十六进制数为nn的字符</td>
</tr>
<tr>
<td>38</td>
<td>\unnnn  </td>
<td>Unicode码为nnnn的字符</td>
</tr>
<tr>
<td>39</td>
<td>\cN  </td>
<td>Control N字符，例如回车（Ctrl-M）就是\cM</td>
</tr>
<tr>
<td>40</td>
<td>\A</td>
<td>字符串的开始（像^但是不依赖于多行选项）</td>
</tr>
<tr>
<td>41</td>
<td>\Z</td>
<td>字符串的结尾或者\n之前的字符串结尾（忽略多行）</td>
</tr>
<tr>
<td></td>
<td>\z </td>
<td>字符串结尾（忽略多行）</td>
</tr>
<tr>
<td>42</td>
<td>\G</td>
<td>当前搜索的开始阶段</td>
</tr>
<tr>
<td>43</td>
<td>\p{name}</td>
<td>命名为name的Unicode类中的任何字符，例如\p{IsGreek} </td>
</tr>
<tr>
<td></td>
<td>(?&gt;exp)</td>
<td>贪婪子表达式，也被称为非回溯子表达式。它只匹配一次然后就不再参与回溯。</td>
</tr>
<tr>
<td>44</td>
<td>(?&lt;x&gt;-&lt;y&gt;exp) or (?-&lt;y&gt;exp)</td>
<td>Balancing group. This is complicated but powerful. It allows named capture groups to be manipulated on a push down/pop up stack and can be used, for example, to search for matching parentheses, which is otherwise not possible with regular expressions. See the example in the project file. </td>
</tr>
<tr>
<td>45</td>
<td>(?im-nsx:exp)</td>
<td>正则表达式选项为子表达式exp </td>
</tr>
<tr>
<td>46</td>
<td>(?im-nsx)</td>
<td>Change the regular expression options for the rest of the enclosing group </td>
</tr>
<tr>
<td></td>
<td>(?(exp)yes|no)</td>
<td>The subexpression exp is treated as a zero-width positive lookahead. If it matches at this point, the subexpression yes becomes the next match, otherwise no is used. </td>
</tr>
<tr>
<td></td>
<td>(?(exp)yes)</td>
<td>Same as above but with an empty no expression </td>
</tr>
<tr>
<td></td>
<td>(?(name)yes|no)</td>
<td>This is the same syntax as the preceding case. If name is a valid group name, the yes expression is matched if the named group had a successful match, otherwise the no expression is matched. </td>
</tr>
<tr>
<td>47 </td>
<td>(?(name)yes)</td>
<td>Same as above but with an empty no expression </td>
</tr>
</table>
<p>表6 我们遗漏的东西。左端的列显示了项目文件中说明这个结构的例子的序号</p>
<p>　　结论</p>
<p>　　我们已经给出了很多例子来说明.NET正则表达式的关键特性，强调使用工具（如Expresso）来测试，实践，然后是用例子来学习。如果你想要深入的研究，网上也有很多在线资源会帮助你更深入的学习。你可以从访问Ultrapico网站开始。如果你想读一本相关书籍，我建议Jeffrey Friedl写的最新版的《Mastering Regular Expressions》。</p>
<p>Code Project中还有很多不错的文章，其中包含下面的教程：</p>
<p>·An Introduction to Regular Expressions by Uwe Keim <br />·Microsoft Visual C# .NET Developer's Cookbook: Chapter on Strings and Regular Expressions</p>
<p>注：本文例子可以从Ultrapico网站下载Expresso测试，点这里下载该程序，点这里察看原文。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-04 21:10:54</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%90%9c%e7%b4%a2/" title="搜索">搜索</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e5%ad%97%e7%ac%a6/" title="字符">字符</a>, <a href="https://www.iamivan.net/tag/%e6%ad%a3%e5%88%99%e8%a1%a8%e8%be%be%e5%bc%8f/" title="正则表达式">正则表达式</a>, <a href="https://www.iamivan.net/tag/%e8%a1%a8%e8%be%be%e5%bc%8f/" title="表达式">表达式</a>, <a href="https://www.iamivan.net/tag/%e9%87%8d%e5%a4%8d/" title="重复">重复</a>, <a href="https://www.iamivan.net/tag/%e6%ad%a3%e5%88%99%e8%a1%a8%e8%be%be%e5%bc%8f30%e5%88%86%e9%92%9f/" title="正则表达式30分钟">正则表达式30分钟</a>, <a href="https://www.iamivan.net/tag/%e9%87%8d%e5%a4%8d%e5%ad%97%e7%ac%a6/" title="重复字符">重复字符</a>, <a href="https://www.iamivan.net/tag/%e9%87%8d%e5%a4%8d%e5%ad%97%e7%ac%a6%e8%a1%a8%e8%be%be%e5%bc%8f/" title="重复字符表达式">重复字符表达式</a>, <a href="https://www.iamivan.net/tag/lookaround/" title="Lookaround">Lookaround</a>, <a href="https://www.iamivan.net/tag/%e6%96%87%e6%9c%ac%e5%8c%b9%e9%85%8d/" title="文本匹配">文本匹配</a>, <a href="https://www.iamivan.net/tag/%e5%90%ab%e7%89%b9%e6%ae%8a%e5%ad%97%e7%ac%a6/" title="含特殊字符">含特殊字符</a>, <a href="https://www.iamivan.net/tag/30b-d/" title="&num;30B&plus;D">&num;30B&plus;D</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>30分钟正则表达式指导的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr2X81M.html" rel="bookmark">正则表达式30分钟入门教程 v2&period;1版&lowbar;正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				正则表达式30分钟入门教程 v2.1 作者:deerchao 来源:unibetter大学生社区 转载请注明来源 目录 本文目标 如何使用本教程 什么是正则表达式? 入门 测试正则表达式 元字符 字符转义 重复 字符类 反义 替换 分组 后向引用 位置指定 负向位置指定 注释 贪婪与懒惰 处理选项 平衡组/递归匹配 还有些什么东西没提到 一些我认为你可能已经知道的术语的参考 网上的资源及本文参考文献 更新说明 本文目标 30分钟内让你明白正则表达式是什么,并对它有一些基本的了解,让你可以在自己的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5OEBb.html" rel="bookmark">30分钟学会正则表达式基础教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基础教程|教程|正则表达式|正则 目录 本文目标 如何使用本教程 正则表达式到底是什么? 入门 测试正则表达式 元字符 字符转义 重复 字符类 反义 替换 分组 后向引用 零宽断言 负向零宽断言 注释 贪婪与懒惰 处理选项 平衡组/递归匹配 还有些什么东西没提到 联系作者 最后,来点广告... 一些我认为你可能已经知道的术语的参考 网上的资源及本文参考文献 更新说明 本文目标 30分钟内让你明白正则表达式是什么,并对它有一些基本的了解,让你可以在自己的程序或网页里使用它. 如何使用本教程 最重要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN1BxPb.html" rel="bookmark">正则表达式30分钟入门教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文系转载,首收录于个人云笔记,个人觉得是相当好的正则入门教程,文章略作修改. 首页 | 常用正则表达式 | 正则表达式测试工具 正则表达式30分钟入门教程 版本:v2.33 (2013-1-10) 作者:deerchao 转载请注明来源 目录 跳过目录 本文目标 如何使用本教程 正则表达式到底是什么东西? 入门 测试正则表达式 元字符 字符转义 重复 字符类 分枝条件 反义 分组 后向引用 零宽断言 负向零宽断言 注释 贪婪与懒惰 处理选项 平衡组/递归匹配 还有些什么东西没提到 联系作者 网			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZEQqwp.html" rel="bookmark">正则表达式30分钟入门教程  专题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				来园子之前写的一篇正则表达式教程,部分翻译自codeproject的The 30 Minute Regex Tutorial. 由于评论里有过长的URL,所以本页排版比较混乱,推荐你到原处查看,看完了如果有问题,再到这里来提出. 一些要说的话: 如果你没有正则表达式的基础,请跟着教程&quot;一步步来&quot;.请不要大概地扫两眼就说看不懂--以这种态度我写成什么样你也看不懂.当我告诉你这是&quot;30分钟入门教程&quot;时,请不要试图在30秒内入门. 事实是,我身边有个才接触电脑,对操作都不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOlEVRb.html" rel="bookmark">正则表达式30分钟入门教程&lbrack;转&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[目录] 正则表达式30分钟入门教程 本文目标 如何使用本教程 正则表达式到底是什么东西? 入门 测试正则表达式 元字符 字符转义 重复 字符类 分枝条件 分组 反义 后向引用 零宽断言 负向零宽断言 注释 贪婪与懒惰 处理选项 平衡组/递归匹配 还有些什么东西没提到 本文目标 30分钟内让你明白正则表达式是什么,并对它有一些基本的了解,让你可以在自己的程序或网页里使用它. 如何使用本教程 别被下面那些复杂的表达式吓倒,只要跟着我一步一步来,你会发现正则表达式其实并没有想像中的那么困难.当然,如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvYmO5b.html" rel="bookmark">学习正则表达式30分钟入门教程&lpar;第二版&rpar;&lowbar;正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于本人内容过多排版比较乱,推荐大家浏览单独网页版 http://www.jb51.net/tools/zhengze.html 本文目标 30分钟内让你明白正则表达式是什么,并对它有一些基本的了解,让你可以在自己的程序或网页里使用它. 如何使用本教程 最重要的是--请给我30分钟,如果你没有使用正则表达式的经验,请不要试图在30秒内入门--除非你是超人 :) 别被下面那些复杂的表达式吓倒,只要跟着我一步一步来,你会发现正则表达式其实并没有你想像中的那么困难.当然,如果你看完了这篇教程之后,发现			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlmKGOp.html" rel="bookmark">30分钟就入门的正则表达式基础教程&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文目标30分钟内让你明白正则表达式是什么,并对它有一些基本的了解,让你可以在自己的程序或网页里使用它. 如何使用本教程 最重要的是--请给我30分钟,如果你没有使用正则表达式的经验,请不要试图在30秒内入门--除非你是超人 :) 别被下面那些复杂的表达式吓倒,只要跟着我一步一步来,你会发现正则表达式其实并没有你想像中的那么困难.当然,如果你看完了这篇教程之后,发现自己明白了很多,却又几乎什么都记不得,那也是很正常的--我认为,没接触过正则表达式的人在看完这篇教程后,能把提到过的语法记住80%以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX9lelz.html" rel="bookmark">正则表达式30分钟入门教程 v2&period;1版</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				运行下面的代码就可以看到 &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Strict//EN&quot; &quot;http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd&quot;&gt; 正则表达式30分钟入门教程 正则表达式30分钟入门教程 v2.1 作者:deerchao 来源:unibetter大学生社区 转载请注明来源 目录 本文目标 如何使用本教程 什么是正则表达式? 入门 测试正则表达			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zea4Oxz.html" rel="bookmark">艾伟&lowbar;转载：正则表达式30分钟入门教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  本文目标 30分钟内让你明白正则表达式是什么,并对它有一些基本的了解,让你可以在自己的程序或网页里使用它. 如何使用本教程 最重要的是--请给我30分钟,如果你没有使用正则表达式的经验,请不要试图在30秒内入门--除非你是超人 :) 别被下面那些复杂的表达式吓倒,只要跟着我一步一步来,你会发现正则表达式其实并没有你想像中的那么困难.当然,如果你看完了这篇教程之后,发现自己明白了很多,却又几乎什么都记不得,那也是很正常的--我认为,没接触过正则表达式的人在看完这篇教程后,能把提到过的语法记住8			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQWoKp.html" rel="bookmark" class="title">阿里云备案获取服务号</a>
					<div>
						备案服务号怎么获得? 1.备案服务号(SN号):例:32a43232-a888-88e8-b9ec-00888be8888f. 是用于在代备案系统(http://aliyun.gein.cn/)提交备 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQvVGM.html" rel="bookmark" class="title">彻底学习Java语言中的覆盖和重载</a>
					<div>
						初次见到这两个单词并没有什么特别的感觉,但是时间长了,却发现书上一会儿用override,一会儿又用overload,搞得我的迷迷糊.于是就做了个总结,希望能对和我一样对这两个概念模糊不清的网友有一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjl5mp.html" rel="bookmark" class="title">html防止表格被撑开的css</a>
					<div>
						css table { table-layout: fixed;word-wrap:break-word;}div { word-wrap:break-word;}					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNP0Db.html" rel="bookmark" class="title">自动交换光网络分级路由技术的研究</a>
					<div>
						自动交换光网络(ASON)是下一代网络(NGN)的核心传送技术.该技术在传统的光网络(如SDH.DWDM.OTN等)的基础上,通过引入控制平面使其具有智能的功能,即光传送网能够根据用户的呼叫请求,在控 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEl4rZz.html" rel="bookmark" class="title">简介Windows 7和Windows 2008 R2中的IIS7&period;5</a>
					<div>
						最近网上关于Windows7的说明几乎全部都是关于它的新UI来说明的,很少有人提及它内置的IIS7.5,这个与我们很大一部分的ASP.net开发人员相关的组件.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElZRAz.html" rel="bookmark" class="title">使用Equinox p2简化Eclipse插件的安装</a>
					<div>
						使用 Equinox p2 的新特性安装 Eclipse 及其插件 简介:本文探索了 Equinox p2 的新特性,该特性首次在 Eclipse V3.4 中亮相.它主要关注早期 Eclipse 版 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLnxKb.html" rel="bookmark" class="title">让Real Player 10的启动速度加快一倍</a>
					<div>
						大家都知道,Real Player 10的启动速度是很慢的.不过,如果按下面的方法对它进行一些调整,问题基本可以解决.在Real文件夹搜索,firstrun.smi和getmedia.ini两个文件, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3ELZM.html" rel="bookmark" class="title">bios里如何关闭软驱</a>
					<div>
						  bios里如何关闭软驱吗? 1.首先在开机的过程中按Del键进入bios界面. 2.然后利用键盘进行操作,选择standard coms features,在弹出的窗口中找到Drive A,回车选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0W37Pb.html" rel="bookmark" class="title">谷歌地图宠物小精灵怎么玩？</a>
					<div>
						  第一步.需要安装最新版的谷歌地图,注意接收一个小小的更新哦!有惊喜! 第二步.进入谷歌地图app后,大家可以在搜索栏的下放看到&quot;Press Start&quot;按钮,点击按钮,你的口袋 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXRlEp.html" rel="bookmark" class="title">linux-如何同时访问阿里云RDS的内外网-ssh-tunnel&sol;snat&sol;dnat</a>
					<div>
						需求一: 之前介绍了windows下如何通过公网IP代理访问内网的RDS数据库,本文将介绍linux下如果通过公网IP来访问内网的RDS. 近期发现使用rinetd相对会更简单和稳定,所以若有此需求可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaO9mM.html" rel="bookmark" class="title">Vim技能修炼教程&lpar;15&rpar; - 时间和日期相关函数</a>
					<div>
						Vimscript武器库 前面我们走马观花地将Vimscript的大致语法过了一遍.下面我们开始深入看一下Vimscript都给我们准备了哪些武器.如果只用这些武器就够了,那么就太好了,只用Vimsc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WA7Jb.html" rel="bookmark" class="title">双11首次全球品牌直采 海外大牌扎堆天猫</a>
					<div>
						电商改变了人们的购物习惯,消费者无需在商场超市排队,便可将品牌商品搬回家,无需出国跨境,便可买遍全球.食品.母婴.个人护理.生鲜等快消品作为天猫双11期间发货量最大的行业,以互联网模式将全球性.时尚性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWydvp.html" rel="bookmark" class="title">visual studio2015 安装 无效的驱动器</a>
					<div>
						问题描述 visual studio2015 安装 无效的驱动器 原来有三个盘C.D.E. vs安装在E盘了. 为了扩大C盘容量把D盘跟C盘合并了,E盘改为D盘 vs需要重新安装.打开以前保留的安装包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAvOYM.html" rel="bookmark" class="title">更新-一个关于activity的问题</a>
					<div>
						问题描述 一个关于activity的问题 我在ListFragment启动一个Activity B,再由这个Activity B开启另一个Activity(扫描二维码信息的),得到扫描信息后 返回Ac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXw3qKM.html" rel="bookmark" class="title">江湖救急！！！！！！</a>
					<div>
						问题描述 各位老大江湖救急!!!!我想通过c#实现pdf文件内容及格式的解析,包括字体的大小.加粗.斜体.下划线.文本对象的位置等等,请各位有过类似经验的老大不吝指导. 解决方案 解决方案二:自己顶起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamWGqb.html" rel="bookmark" class="title">求解决方案-安卓开发手机上传图片到ftp</a>
					<div>
						问题描述 安卓开发手机上传图片到ftp 用手机连接ftp服务器,在手机连接wifi情况下可以登陆到ftp,但是用移动网络就无法连接,怎么解决呢 解决方案 ftp上传图片的简单用法上传文件或图片到ftp					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NPoaz.html" rel="bookmark" class="title">c语言-为什么编写c程序时，200&ast;5&ast;0&period;85等于849？？？？</a>
					<div>
						问题描述 为什么编写c程序时,200*5*0.85等于849???? 不应该等于850吗??? #include int main(void) { const int danjia = 5; int  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrX3y1z.html" rel="bookmark" class="title">布局-请大神们解决控件位置的问题 ，详情看下面的 补充 ！</a>
					<div>
						问题描述 请大神们解决控件位置的问题 ,详情看下面的 补充 ! 在Android中 graphical layout 中 添加一张图片为背景,用的是分辨率(3.7WVGA480*800) ,然后在添加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBkwmb.html" rel="bookmark" class="title">方法嵌套方法-java中非static方法内部能否嵌套非static方法？</a>
					<div>
						问题描述 java中非static方法内部能否嵌套非static方法? class NiMingLei { public static void main(String[] args) { Outer ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBKrvb.html" rel="bookmark" class="title">llpp v12发布 PDF页面程序</a>
					<div>
						llpp是一个基于MuPDF的PDF页面程序. llpp v12该版本支持MuPDF1.0同步,拆分列模式,提示模式A LA Conkeror,支持运行在Cygwin X和XQuartz. 软件信息: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAdlZM.html" rel="bookmark" class="title">2017光伏指标已预扣11GW 地面型需求可能走缓</a>
					<div>
						中国国家能源局在2016年12月底开放符合资格的地方申请地面型电站指标追加,统计至今已有约11GW申请.由于这将直接排挤2017年的地面型电站指标,因此今年的地面型电站需求很有可能受到影响. 由于中国 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXY1yz.html" rel="bookmark" class="title">关于Google拒绝访问的猜测</a>
					<div>
						前段时间,Google无法访问,好在还有个IP 203.208.46.200 还能访问,但今天访问这个IP时出现了下面的情况. We're sorry-- but your computer or n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXJxOz.html" rel="bookmark" class="title">学习java，可以往哪些方面发展？？</a>
					<div>
						问题描述 我想找个目标好好学习,但是又不知道可以往哪些方面学习,希望能够说说哪些发展方面,再根据自身情况,考虑考虑!! 解决方案 解决方案二:J2EE,J2ME解决方案三:EE企业平台解决方案四:建议 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLxanM.html" rel="bookmark" class="title">loadrunner问题-loadrunner中analysis如何显示所有的图？</a>
					<div>
						问题描述 loadrunner中analysis如何显示所有的图? loadrunner中analysis如何显示所有的图?显示出所有的图,在哪里设置?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeog58M.html" rel="bookmark" class="title">《基于ArcGIS的Python编程秘笈（第2版）》&mdash;&mdash;1&period;4　总结</a>
					<div>
						1.4 总结 本章介绍了Python编程的基本概念,理解这些基本概念才能编写出有效的地理处理脚本.在本章的开头简略介绍了如何在IDLE开发环境下编写和调试Python脚本,讲解了如何创建一个新的脚本. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPllR0p.html" rel="bookmark" class="title">PHP使用CURL实现多线程抓取网页&lowbar;php技巧</a>
					<div>
						PHP 利用 Curl Functions 可以完成各种传送文件操作,比如模拟浏览器发送GET,POST请求等等,受限于php语言本身不支持多线程,所以开发爬虫程序效率并不高,这时候往往需 要借助Cu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqZ2Ap.html" rel="bookmark" class="title">使用jQuery&plus;HttpHandler&plus;xml模拟一个三级联动的例子&lowbar;jquery</a>
					<div>
						如下是实现过程: 第一步:准备xml文件,并放置在网站根目录下,名为Area.xml 复制代码 代码如下: &lt;?xml version=&quot;1.0&quot; encoding=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLB4BM.html" rel="bookmark" class="title">syn-怎么禁止本地机发送RST报文</a>
					<div>
						问题描述 怎么禁止本地机发送RST报文 本地机发出SYN收到服务器SYN/ACK包,但是本地返回了RST包.请问怎么才能拦截这个RST 包 试了有人说的iptables也失败了 iptables -A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze085jp.html" rel="bookmark" class="title">mysql-MYSQL建表字段问题 10101010</a>
					<div>
						问题描述 MYSQL建表字段问题 10101010 想请问下:MYSQL建立一个表的字段假如是用来存储用户名的,那这个字段要用什么的比较好,我用阿里云的MYSQL,他死活不让我建,好像是字段长度问题: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2YyyVz.html" rel="bookmark" class="title">手机网站上放黄色小说被查处</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 站长网06月29日 据大洋 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.044 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
